<?php

namespace App\Entity;

use App\Entity\Base\BaseEntity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="App\Repository\CancelledServiceItemRepository")
 * @ORM\Table(name="cancelled_service_item")
 * @ORM\HasLifecycleCallbacks()
 */

class CancelledServiceItemEntity extends BaseEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @ORM\Column(name="quantity", type="decimal", precision=12, scale=2, nullable=true)
     */
    protected $quantity;
    
    /**
     * @ORM\ManyToOne(targetEntity="ServiceItemEntity", inversedBy="cancelledServiceItems")
     * @ORM\JoinColumn(name="service_item_id", referencedColumnName="id", nullable=true)
     */
    protected $serviceItem;

    /**
     * @ORM\ManyToOne(targetEntity="LodgeServiceEntity", inversedBy="cancelledServiceItems")
     * @ORM\JoinColumn(name="lodge_service_id", referencedColumnName="id", nullable=true)
     */
    protected $lodgeService;

    /**
     * @ORM\ManyToOne(targetEntity="GroomingServiceEntity", inversedBy="cancelledServiceItems")
     * @ORM\JoinColumn(name="grooming_service_id", referencedColumnName="id", nullable=true)
     */
    protected $groomingService;

        /**
     * @ORM\ManyToOne(targetEntity="InventoryEntity", inversedBy="cancelledServiceItems")
     * @ORM\JoinColumn(name="inventory_id", referencedColumnName="id", nullable=true)
     */
    protected $inventory;

    

    public function __construct($data = null)
    {
    }


    /**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return CancelledServiceItemEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					Cancelledr Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getQuantity(): ?string
    {
        return $this->quantity;
    }

    public function setQuantity(?string $quantity): self
    {
        $this->quantity = str_replace(',','', $quantity);

        return $this;
    }

    public function getServiceItem(): ?ServiceItemEntity
    {
        return $this->serviceItem;
    }

    public function setServiceItem(?ServiceItemEntity $serviceItem): self
    {
        $this->serviceItem = $serviceItem;

        return $this;
    }

    public function getLodgeService(): ?LodgeServiceEntity
    {
        return $this->lodgeService;
    }

    public function setLodgeService(?LodgeServiceEntity $lodgeService): self
    {
        $this->lodgeService = $lodgeService;

        return $this;
    }

    public function getGroomingService(): ?GroomingServiceEntity
    {
        return $this->groomingService;
    }

    public function setGroomingService(?GroomingServiceEntity $groomingService): self
    {
        $this->groomingService = $groomingService;

        return $this;
    }

    public function getInventory(): ?InventoryEntity
    {
        return $this->inventory;
    }

    public function setInventory(?InventoryEntity $inventory): self
    {
        $this->inventory = $inventory;

        return $this;
    }



   

  

   
}

