<?php

namespace App\Entity;

use App\Entity\Base\BaseEntity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="App\Repository\ClientPetPhotoRepository")
 * @ORM\Table(name="client_pet_photo")
 * @ORM\HasLifecycleCallbacks()
 */

class ClientPetPhotoEntity extends BaseEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @ORM\Column(name="file_description", type="string", nullable=true)
     */
    protected $fileDescription;

    /**
     * @ORM\Column(name="parsed_file_description", type="string", nullable=true)
     */
    protected $parsedFileDescription;

    /**
     * @ORM\ManyToOne(targetEntity="ClientPetEntity", inversedBy="clientPetPhotos")
     * @ORM\JoinColumn(name="client_pet_id", referencedColumnName="id", nullable=true)
     */
    protected $clientPet;
    
    public function __construct($data = null)
    {
    }


    /**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return ClientPetPhotoEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }


        /**
     * Remove the file from the disk
     *
     * @ORM\PreRemove
     */
    public function removeFile() {

        $file = $this->getUploadRootDir() . '/' . $this->parsedFileDescription;
        if(!empty($this->profilePic) && file_exists($file)) unlink($file);
    }

        /**
     * Get uploadDir
     *
     * @return string
     */
    public function getUploadDir() {

        return '/uploads/file';
    }

    /**
     * Get uploadRootDir
     *
     * @return string
     */
    public function getUploadRootDir() {

        return __DIR__ . './../../public' . $this->getUploadDir();
    }

        /**
     * get fileWebPath
     *
     * @return string
     */
    public function getFileWebPath() {

        $parsedDesc = $this->parsedFileDescription;
        $file = $this->getUploadRootDir() . '/' . $parsedDesc;
     
        if(!empty($parsedDesc) ) {
            return   $this->getUploadDir() . '/' . $parsedDesc;
        } else {
            return '';
        }

       
    }


    /*--------------------------------------------------------------------------------------------------------*/
    /*					User Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getFileDescription(): ?string
    {
        return $this->fileDescription;
    }

    public function setFileDescription(?string $fileDescription): self
    {
        $this->fileDescription = $fileDescription;

        return $this;
    }

    public function getParsedFileDescription(): ?string
    {
        return $this->parsedFileDescription;
    }

    public function setParsedFileDescription(?string $parsedFileDescription): self
    {
        $this->parsedFileDescription = $parsedFileDescription;

        return $this;
    }

    public function getClientPet(): ?ClientPetEntity
    {
        return $this->clientPet;
    }

    public function setClientPet(?ClientPetEntity $clientPet): self
    {
        $this->clientPet = $clientPet;

        return $this;
    }


 
}

