<?php

namespace App\Entity;

use App\Entity\Base\BaseEntity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="App\Repository\GroomingPaymentRepository")
 * @ORM\Table(name="grooming_payment")
 * @ORM\HasLifecycleCallbacks()
 */

class GroomingPaymentEntity extends BaseEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @ORM\Column(name="amount", type="decimal", precision=12, scale=2, nullable=true)
     */
    protected $amount;

    /**
     * @ORM\Column(name="payment_date", type="datetime", nullable=false)
     */
    protected $paymentDate;
    
    /**
     * @ORM\ManyToOne(targetEntity="GroomingEntity", inversedBy="groomingPayments")
     * @ORM\JoinColumn(name="grooming_id", referencedColumnName="id", nullable=true)
     */
    protected $grooming;

    /**
     * @ORM\ManyToOne(targetEntity="PaymentTypeEntity", inversedBy="groomingPayments")
     * @ORM\JoinColumn(name="payment_type_id", referencedColumnName="id", nullable=true)
     */
    protected $paymentType;


    public function __construct($data = null)
    {
    }


    /**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return GroomingPaymentEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					User Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getAmount(): ?string
    {
        return $this->amount;
    }

    public function setAmount(?string $amount): self
    {
        $this->amount = str_replace(',', '', $amount);

        return $this;
    }

    public function getPaymentDate(): ?\DateTimeInterface
    {
        return $this->paymentDate;
    }

    public function setPaymentDate(\DateTimeInterface $paymentDate): self
    {
        $this->paymentDate = $paymentDate;

        return $this;
    }

    public function getGrooming(): ?GroomingEntity
    {
        return $this->grooming;
    }

    public function setGrooming(?GroomingEntity $grooming): self
    {
        $this->grooming = $grooming;

        return $this;
    }

    public function getPaymentType(): ?PaymentTypeEntity
    {
        return $this->paymentType;
    }

    public function setPaymentType(?PaymentTypeEntity $paymentType): self
    {
        $this->paymentType = $paymentType;

        return $this;
    }



   
   
}

