<?php

namespace App\Entity;

use App\Entity\Base\BaseEntity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="App\Repository\LodgePaymentRepository")
 * @ORM\Table(name="lodge_payment")
 * @ORM\HasLifecycleCallbacks()
 */

class LodgePaymentEntity extends BaseEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @ORM\Column(name="amount", type="decimal", precision=12, scale=2, nullable=true)
     */
    protected $amount;

    /**
     * @ORM\Column(name="payment_date", type="datetime", nullable=false)
     */
    protected $paymentDate;
    
    /**
     * @ORM\ManyToOne(targetEntity="LodgeEntity", inversedBy="lodgePayments")
     * @ORM\JoinColumn(name="lodge_id", referencedColumnName="id", nullable=true)
     */
    protected $lodge;

    /**
     * @ORM\ManyToOne(targetEntity="PaymentTypeEntity", inversedBy="lodgePayments")
     * @ORM\JoinColumn(name="payment_type_id", referencedColumnName="id", nullable=true)
     */
    protected $paymentType;


    public function __construct($data = null)
    {
    }


    /**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return LodgePaymentEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					User Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getAmount(): ?string
    {
        return $this->amount;
    }

    public function setAmount(?string $amount): self
    {
        $this->amount = str_replace(',','', $amount);

        return $this;
    }

    public function getPaymentDate(): ?\DateTimeInterface
    {
        return $this->paymentDate;
    }

    public function setPaymentDate(\DateTimeInterface $paymentDate): self
    {
        $this->paymentDate = $paymentDate;

        return $this;
    }

    public function getLodge(): ?LodgeEntity
    {
        return $this->lodge;
    }

    public function setLodge(?LodgeEntity $lodge): self
    {
        $this->lodge = $lodge;

        return $this;
    }

    public function getPaymentType(): ?PaymentTypeEntity
    {
        return $this->paymentType;
    }

    public function setPaymentType(?PaymentTypeEntity $paymentType): self
    {
        $this->paymentType = $paymentType;

        return $this;
    }

   
   
}

