<?php

namespace App\Entity;

use App\Entity\Base\BaseEntity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="App\Repository\ScheduleRepository")
 * @ORM\Table(name="schedule")
 * @ORM\HasLifecycleCallbacks()
 */

class ScheduleEntity extends BaseEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    
    /**
     * @ORM\Column(name="remarks", type="text", nullable=true)
     */
    protected $remarks;

    
    /**
     * @ORM\Column(name="status", type="string", nullable=true)
     */
    protected $status;

    
    /**
     * @ORM\Column(name="schedule_type", type="string", nullable=true)
     */
    protected $scheduleType;

    /**
     * @ORM\Column(name="schedule_date", type="datetime", nullable=false)
     */
    protected $scheduleDate;
    
    /**
     * @ORM\ManyToOne(targetEntity="BranchEntity", inversedBy="schedules")
     * @ORM\JoinColumn(name="branch_id", referencedColumnName="id", nullable=true)
     */
    protected $branch;

    /**
     * @ORM\ManyToOne(targetEntity="ClientPetEntity", inversedBy="schedules")
     * @ORM\JoinColumn(name="client_pet_id", referencedColumnName="id", nullable=true)
     */
    protected $clientPet;


    public function __construct()
    {
    }

    
    /*--------------------------------------------------------------------------------------------------------*/
    /*					Schedule Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/



/**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return ScheduleEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }


    /*--------------------------------------------------------------------------------------------------------*/
    /*					    Defined Setters and Getters													      */
    /*--------------------------------------------------------------------------------------------------------*/

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getRemarks(): ?string
    {
        return $this->remarks;
    }

    public function setRemarks(?string $remarks): self
    {
        $this->remarks = $remarks;

        return $this;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(?string $status): self
    {
        $this->status = $status;

        return $this;
    }

    public function getScheduleType(): ?string
    {
        return $this->scheduleType;
    }

    public function setScheduleType(?string $scheduleType): self
    {
        $this->scheduleType = $scheduleType;

        return $this;
    }

    public function getScheduleDate(): ?\DateTimeInterface
    {
        return $this->scheduleDate;
    }

    public function setScheduleDate(\DateTimeInterface $scheduleDate): self
    {
        $this->scheduleDate = $scheduleDate;

        return $this;
    }

    public function getBranch(): ?BranchEntity
    {
        return $this->branch;
    }

    public function setBranch(?BranchEntity $branch): self
    {
        $this->branch = $branch;

        return $this;
    }

    public function getClientPet(): ?ClientPetEntity
    {
        return $this->clientPet;
    }

    public function setClientPet(?ClientPetEntity $clientPet): self
    {
        $this->clientPet = $clientPet;

        return $this;
    }
   
}
