<?php

namespace App\Repository;

use App\Entity\ClientEntity;
use App\Entity\BranchEntity;



/**
 * ClientRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ClientRepository extends \Doctrine\ORM\EntityRepository
{
    public function validate($form) {

        $errors = array();
        $action = $form['action'];

               // d = delete
               if($action !== 'd') {

            
                $clientExists = $this->getEntityManager()->getRepository(ClientEntity::class)
                    ->createQueryBuilder('c')
                    ->where('c.id != :id')
                    ->andWhere('c.firstName = :firstName')
                    ->andWhere('c.lastName = :lastName')
                    ->andWhere('c.isDeleted = :is_deleted')
                    ->andWhere('c.branch = :branch')
                    ->setParameters(array(
                        'id' => $form['id'],
                        'firstName' => $form['first_name'],
                        'lastName' => $form['last_name'],
                        'is_deleted' => false,
                        'branch' => $form['branch']
                    ))
                    ->getQuery()->getResult();
                
                if($action != 'u' && $clientExists){
                    $errors[] = 'Client already exist.';
                }
    
                if(empty($form['first_name'])){
                    $errors[] = 'First Name should not be blank.';
                }

                if(empty($form['last_name'])){
                    $errors[] = 'Last Name should not be blank.';
                }
    
              
            }
        return $errors;
    }

    public function ajax_list(array $get, array $userData){
        $columns = array(
          
            array('CONCAT(c.`first_name`, " ", c.`last_name`)', 'CONCAT(c.`first_name`, " ", c.`last_name`)', 'client'),
            array('c.`email`', 'c.`email`', 'email'),
            array('CONCAT(c.`contact_no`, ",", c.`secondary_contact_no`)', 'CONCAT(c.`contact_no`, ",", c.`secondary_contact_no`)', 'contactNo'),
            array('c.`id`', "c.`id`"),


        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `client` c";
        $joins = "";
        $sqlWhere = " WHERE (c.`is_deleted` = 0 OR  c.`is_deleted` IS NULL) ";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();
       
        if($userData['type'] != 'Super Admin'){
            $sqlWhere .= ' AND c.`branch_id` = ' . base64_decode($userData['branchId']);
        }

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

          /*
         * Filtering
         */
        if(!empty($get['q']) && $get['q']){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['q'] . "%";
            }
        } else {
            /*
            * Filtering
            */
            if(isset($get['search']) && $get['search']['value'] != ''){
                $aLikes = array();
                foreach($get['columns'] as $key => $column) {
                    if($column['searchable']=='true') {
                        $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                    }
                }
                foreach($asColumns as $asColumn) {
                    $aLikes[] = $asColumn . ' LIKE :searchValue';
                }
                if(count($aLikes)) {
                    $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                    $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
                }
            }

        }

    
        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);


              /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];
        $formUrl = $url . '/client/ajax_form';  
        $hasUpdate = false;
        $url = $get['url'];
        $hasDelete = false;

        if($userData['type'] == 'Super Admin'|| in_array('Client Update', $userData['accesses'])){
            $hasUpdate = true;
        }

        if($userData['type'] == 'Super Admin'|| in_array('Client Delete', $userData['accesses'])){
            $hasDelete = true;
        }


        foreach($result as $row) {

            $id = base64_encode($row['id']);
           
            $action = $hasDelete ? '<a href="javascript:void(0);" class="delete-btn action-button-style btn btn-success table-btn" data-id="'.$id.'" data-message="Are you sure you want to delete this Record?">Delete</a>' : "";
            $action .= $hasUpdate ? ' <a href="javascript:void(0);" class="fullscreen href-modal action-btn action-button-style btn btn-primary table-btn" data-id="'.$id.'"  data-url="'.$formUrl.'" data-action="u">Update</a>' : "";

            $values = array(
                $row['client'],
                $row['email'],
                $row['contactNo'],
                $action
            );

            $output['data'][] = $values;
        }

        unset($result);
        return $output;
    }



    public function autocompleteSuggestions($q, array $userData) {
       
        $stmtParams = array();

        $qs = $q['query'];

        $where = ' WHERE b.`description` LIKE :description';
        $where .= ' AND b.`branch_id` = '.$userData['branchId'].'';
        $stmtParams['description'] =  "%$qs%"; 

        $sql = "
            SELECT
                 b.`id`,
                 CONCAT(c.`first_name`, ', ', c.`last_name`, ' - ' , 'p.`name`') AS data,
                 CONCAT(c.`first_name`, ', ', c.`last_name`, ' - ' , 'p.`name`') AS value,
            FROM `client_pet` cp
            LEFT JOIN `client` c ON c.`id` = cp.`client_id`
            LEFT JOIN `pet` p ON p.`id` = cp.`pet_id`
            ". $where ."
            AND (cp.`is_deleted` = 0 OR  cp.`is_deleted` IS NULL)            
            ORDER BY CONCAT(c.`first_name`, ', ', c.`last_name`, ' - ' , 'p.`name`')
            LIMIT 0,20
        ";


        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }




    private function getRandomColor() {
        $rand = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f');
        $color = '#'.$rand[rand(0,15)].$rand[rand(0,15)].$rand[rand(0,15)].$rand[rand(0,15)].$rand[rand(0,15)].$rand[rand(0,15)];
        return $color;
    }

}
