<?php

namespace App\Repository;

use App\Entity\UseServiceItemEntity;

/**
 * UseServiceItemRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class UseServiceItemRepository extends \Doctrine\ORM\EntityRepository
{


    public function ajax_list(array $get, array $userData){

        $columns = array(
            array('DATE_FORMAT(usi.`created_at`, "%m/%d/%Y")', 'DATE_FORMAT(usi.`created_at`, "%m/%d/%Y")', 'createdAt'),
            array('IFNULL(l.`transaction_no`,g.`transaction_no` )', 'IFNULL(l.`transaction_no`,g.`transaction_no` )', 'transactionNo'),
            array('usi.`quantity`', 'usi.`quantity`', 'quantity')
        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `use_service_item` usi";
        $sqlWhere = "WHERE usi.`is_deleted` = 0";
        $joins = " LEFT JOIN `lodge_service` ls ON ls.`id` = usi.`lodge_service_id`";
        $joins .= " LEFT JOIN `lodge` l ON l.`id` = ls.`lodge_id`";
        $joins .= " LEFT JOIN `grooming_service` gs ON gs.`id` = usi.`grooming_service_id`";
        $joins .= " LEFT JOIN `grooming` g ON g.`id` = gs.`grooming_id`";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();

        if($userData['type'] != 'Super Admin'){

            $sqlWhere .= " AND (l.`branch_id` = :branchId OR g.`branch_id` = :branchId) ";
            $stmtParams['branchId'] =  base64_decode($userData['branchId']);
        }

        if(isset($get['inventoryId'])){
            $sqlWhere.= " AND usi.`inventory_id` = '" . base64_decode($get['inventoryId']) . "'";
        }

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

        /*
         * Filtering
         */
        if(isset($get['search']) && $get['search']['value'] != ''){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
            }
        }

        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);


              /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];

        foreach($result as $row) {


            $values = array(
                $row['createdAt'],
                $row['transactionNo'],
                $row['quantity'],
            );

            $output['data'][] = $values;
        }

        unset($result);

        return $output;
    }



   
  

}
